%define name            checkstyle
%define version         3.0
%define release         1jpp
%define javadir         %{_datadir}/java
%define javadocdir      %{_datadir}/javadoc
%define section         free

# -----------------------------------------------------------------------------

Name:           %{name}
Version:        %{version}
Release:        %{release}
Summary:        Java source code checker
License:        LGPL
Group:          Development/Build Tools
Vendor:         JPackage Project
Distribution:   JPackage
Source0:        http://download.sf.net/checkstyle/checkstyle-src-3.0.tar.gz
Source1:        %{name}-script
Patch0:         %{name}-build.patch
URL:            http://checkstyle.sourceforge.net/
Requires:       ant, antlr >= 2.7.1, regexp >= 1.2, jakarta-commons-beanutils
Requires:       jakarta-commons-cli, jakarta-commons-logging
Requires:       jakarta-commons-collections, jpackage-utils, jaxp_parser_impl
BuildRequires:  ant >= 1.5, ant-optional, junit, antlr >= 2.7.1, regexp >= 1.2
BuildRequires:  jakarta-commons-beanutils, jakarta-commons-cli, xalan-j2
BuildRequires:  junit, jakarta-commons-collections, jakarta-commons-logging
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
A tool for checking Java source code for adherence to a set of rules.

%package demo
Group:          Development/Build Tools
Summary:        Demos for %{name}
Requires:       %{name} = %{version}-%{release}

%description demo
Demonstrations and samples for %{name}.

%package javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}

%description javadoc
Javadoc for %{name}.

%package manual
Group:          Development/Build Tools
Summary:        Manual for %{name}

%description manual
Manual for %{name}.

# -----------------------------------------------------------------------------

%prep
%setup -q -n %{name}-src-%{version}
%patch0 -p0
# remove all binary libs
find . -name "*.jar" -exec rm -f {} \;

# -----------------------------------------------------------------------------

%build
export CLASSPATH=\
%{javadir}/antlr.jar:\
%{javadir}/regexp.jar:\
%{javadir}/jakarta-commons-beanutils.jar:\
%{javadir}/jakarta-commons-collections.jar:\
%{javadir}/jakarta-commons-cli.jar:\
%{javadir}/jakarta-commons-logging.jar:\
%{javadir}/xalan-j2.jar:\
%{javadir}/junit.jar

ant -Dbuild.sysclasspath=last run.tests build.bindist

# -----------------------------------------------------------------------------

%install
rm -rf $RPM_BUILD_ROOT

# jar
mkdir -p $RPM_BUILD_ROOT%{javadir}
cp -p target/dist/%{name}-%{version}/%{name}-%{version}.jar \
  $RPM_BUILD_ROOT%{javadir}
(cd $RPM_BUILD_ROOT%{javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# script
mkdir -p $RPM_BUILD_ROOT%{_bindir}
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{_bindir}/%{name}

# javadoc
mkdir -p $RPM_BUILD_ROOT%{javadocdir}/%{name}-%{version}
cp -pr target/dist/%{name}-%{version}/docs/api/* \
  $RPM_BUILD_ROOT%{javadocdir}/%{name}-%{version}
rm -rf target/dist/%{name}-%{version}/docs/api

# demo
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%name
cp -pr target/dist/%{name}-%{version}/contrib/* \
  $RPM_BUILD_ROOT%{_datadir}/%name/

# -----------------------------------------------------------------------------

%clean
rm -rf $RPM_BUILD_ROOT

# -----------------------------------------------------------------------------

%files
%defattr(0644,root,root,0755)
%doc LICENSE README TODO
%{javadir}/*
%attr(0755,root,root) %{_bindir}/*

%files demo
%defattr(0644,root,root,0755)
%{_datadir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{javadocdir}/%{name}-%{version}

%files manual
%defattr(0644,root,root,0755)
%doc target/dist/%{name}-%{version}/docs/*

# -----------------------------------------------------------------------------

%changelog
* Sat Mar  1 2003 Ville Skytt <ville.skytta at iki.fi> - 3.0-1jpp
- Update to 3.0.
- Run unit tests during build.
- Separate manual package.

* Sat Sep 14 2002 Ville Skytt <ville.skytta at iki.fi> 2.4-1jpp
- 2.4.
- No RPM macros in source URL.
- Use (patched) ant build.bindist task to fix docs.

* Thu Jul 11 2002 Ville Skytt <ville.skytta at iki.fi> 2.3-2jpp
- Unbreak build.
- Add shell script.

* Tue Jul  9 2002 Ville Skytt <ville.skytta at iki.fi> 2.3-1jpp
- Updated to 2.3.
- Use sed instead of bash 2 extension when symlinking jars during build.
- BuildRequires ant-optional.

* Fri May 10 2002 Ville Skytt <ville.skytta at iki.fi> 2.2-1jpp
- Updated to 2.2.
- Added versioned requirements.
- Fixed Distribution and Group tags.
- Added demo package.

* Sun Mar 03 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.1-1jpp
- first jpp release
